// FrameGrabberTestDoc.cpp : implementation of the CFrameGrabberTestDoc class
//
// (c) Vadim Gorbatenko, 1999 
// gvv@mail.tomsknet.ru
// All rights reserved
//

#include "stdafx.h"
#include "math.h"
#include "FrameGrabberTest.h"

#include "FrameGrabberTestDoc.h"

// testing stuff
#include <windows.h>		// Header File For Windows
#include <stdio.h>			// Header File For Standard I/O Routines
#include <stdlib.h>			// Header File For Standard Library
#include <gl\gl.h>			// Header File For The OpenGL32 Library
#include <gl\glu.h>			// Header File For The GLu32 Library
#include <mmsystem.h>		
#include "objbase.h"	// Needed for COM functionality
// import functions in MT object
#include "IMTObj.h"
// GUIDs of MT object
#include "IMTObj_i.c"


// return values for MT_GetOrientation function
#define MT_NEWDATA			1
#define MT_NODATA			2
#define MT_NOSENSORID		3
#define MT_INCOMPLETE		4
#define MT_CHECKSUMERROR	5
#define MT_NOPORT			6
#define MT_NOCALIBVALUES	7
#define MT_POWERLOSS		8

// output possiblities for MT object
#define MT_LOGQUATERNION	0
#define MT_LOGEULER			1
#define MT_LOGROTMATRIX		2


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define	PROCESSOR_PAUSED			0
#define	PROCESSOR_SIMPLE_VIEWER		1
#define	PROCESSOR_IMAGE_FILTER		2
#define	PROCESSOR_MOTION_DETECTOR	3
#define PROCESSOR_GET_DATA          4
#define PROCESSOR_INIT_WINDOW       5
#define PROCESSOR_RUN_GL            6


//////////////////////////////////// Globals for openGL
GLfloat spec[]={1.0, 1.0 ,1.0 ,1.0};      //sets specular highlight of balls
GLfloat posl[]={0,-400,0,1};               //position of light source
GLfloat amb[]={0.5f, 0.5f, 0.5f ,1.0f};   //global ambient
GLfloat amb2[]={0.6f, 0.6f, 0.6f ,1.0f};  //ambient of lightsource
float camera_rotation=0;                  //holds rotation around the Y axis
float vert_rotation=0;
double dir[3] = {0,0,10};
double pos[3] = {0,0,-500};

// Globals for MT9
IMotionTracker* pMT; 
short g_nMode = MT_LOGEULER;
float fOrientationData[9] = {0};



HDC				hDC=NULL;			// Private GDI Device Context
HGLRC			hRC=NULL;			// Permanent Rendering Context
HWND			hWnd=NULL;			// Holds Our Window Handle
HINSTANCE		hInstance;			// Holds The Instance Of The Application

DEVMODE			DMsaved;			// Saves the previous screen settings (NEW)

bool			keys[256];			// Array Used For The Keyboard Routine
bool			active=TRUE;		// Window Active Flag Set To TRUE By Default
bool			fullscreen=TRUE;	// Fullscreen Flag Set To Fullscreen Mode By Default

void InitVars();
BOOL GetMT9Data();
void SetupFilter();
void killMT9();
void initMT9();
int ProcessKeys();
LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	// Declaration For WndProc
int glMain(LPBITMAPINFO*);
int DrawGLScene(LPBITMAPINFO*);
BOOL CreateGLWindow(char*, int, int, int, bool);

LPBITMAPINFO *frame;
////////////////////////////////



//forward definition for motion detector
LONG	summ_rect_arena32(LPBYTE data, int dx, int dy, int ptX, int ptY, int rx, int ry);
LONG	summ_rect_arena24(LPBYTE data, int dx, int dy, int ptX, int ptY, int rx, int ry);
/////////////////////////////////////////////////////////////////////////////
// CFrameGrabberTestDoc

IMPLEMENT_DYNCREATE(CFrameGrabberTestDoc, CDocument)

BEGIN_MESSAGE_MAP(CFrameGrabberTestDoc, CDocument)
	//{{AFX_MSG_MAP(CFrameGrabberTestDoc)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_SIMPLE_FILTER, OnUpdateSimpleFilter)
	ON_UPDATE_COMMAND_UI(ID_SIMPLE_VIEWER, OnUpdateSimpleViewer)
	ON_UPDATE_COMMAND_UI(ID_DETECTOR, OnUpdateDetector)
	ON_UPDATE_COMMAND_UI(ID_GETDATA, OnUpdateGetData)
	ON_UPDATE_COMMAND_UI(ID_INIT_WINDOW, OnUpdateInitWindow)
	ON_COMMAND(ID_DETECTOR, OnDetector)
	ON_COMMAND(ID_SIMPLE_FILTER, OnSimpleFilter)
	ON_COMMAND(ID_SIMPLE_VIEWER, OnSimpleViewer)
	ON_COMMAND(ID_GETDATA, OnGetData)
	ON_COMMAND(ID_INIT_WINDOW, OnInitWindow)
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_COMMAND(ID_PAUSE, OnPause)
	ON_UPDATE_COMMAND_UI(ID_PAUSE, OnUpdatePause)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFrameGrabberTestDoc construction/destruction

CFrameGrabberTestDoc::CFrameGrabberTestDoc()
{

}

CFrameGrabberTestDoc::~CFrameGrabberTestDoc()
{
}

BOOL CFrameGrabberTestDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	m_ProcessorMode = PROCESSOR_SIMPLE_VIEWER;

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CFrameGrabberTestDoc diagnostics

#ifdef _DEBUG
void CFrameGrabberTestDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CFrameGrabberTestDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFrameGrabberTestDoc commands

void CFrameGrabberTestDoc::OnEditCopy() 
{
	if(m_ImageBitmap.GetSafeHandle() && 
		AfxGetMainWnd()->OpenClipboard())
	{
		EmptyClipboard();
		SetClipboardData(CF_DIB, m_ImageBitmap.DibFromBitmap());
		CloseClipboard();
	}
	
}

void CFrameGrabberTestDoc::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
		pCmdUI->Enable((BOOL)m_ImageBitmap.GetSafeHandle());
}

#define	IMAGEWIDTH(lpd) ((LPBITMAPINFOHEADER)lpd)->biWidth
#define	IMAGEHEIGHT(lpd) ((LPBITMAPINFOHEADER)lpd)->biHeight
#define	IMAGEBITS(lpd) ((LPBITMAPINFOHEADER)lpd)->biBitCount
#define	IMAGEDATA(lpd) (((LPBYTE)lpd) + (((LPBITMAPINFOHEADER)lpd)->biSize))

// This method called by CFrameGrabberTestView
// 
void	CFrameGrabberTestDoc::ProcessImage(LPBITMAPINFO lpBi)
{
	static BOOL bRunNow = FALSE;
	if(!lpBi || bRunNow)	return;
	bRunNow = TRUE;
	switch(m_ProcessorMode)
	{
	case PROCESSOR_SIMPLE_VIEWER:
				m_ImageBitmap.CreateFromDib(lpBi);
				UpdateAllViews(NULL);	break;
	case PROCESSOR_IMAGE_FILTER:
				if(IMAGEBITS(lpBi)!=32&&
					IMAGEBITS(lpBi)!=24)
				{
					AfxMessageBox("Can't run filter: unsupported color resolution!",MB_ICONWARNING);
					m_ProcessorMode =PROCESSOR_SIMPLE_VIEWER;
					break;
				}

				if(ApplyFilter(lpBi))
				{	m_ImageBitmap.CreateFromDib(lpBi);
					UpdateAllViews(NULL);}	break;
	case PROCESSOR_MOTION_DETECTOR:
				if(IMAGEBITS(lpBi)!=32&&
					IMAGEBITS(lpBi)!=24)
				{
					AfxMessageBox("Can't run motion detector: unsupported color resolution!",MB_ICONWARNING);
					m_ProcessorMode =PROCESSOR_SIMPLE_VIEWER;
					break;
				}
				if(RunDetector(lpBi))
				{	m_ImageBitmap.CreateFromDib(lpBi);
					UpdateAllViews(NULL);}	break;
	case PROCESSOR_GET_DATA:
				if(IMAGEBITS(lpBi)!=32&&
					IMAGEBITS(lpBi)!=24)
				{
					AfxMessageBox("Can't get pixel data: unsupported color resolution!",MB_ICONWARNING);
					m_ProcessorMode =PROCESSOR_SIMPLE_VIEWER;
					break;
				}

				if(GetData(lpBi))
				{	m_ImageBitmap.CreateFromDib(lpBi);
					UpdateAllViews(NULL);}	break;
		case PROCESSOR_INIT_WINDOW:
				initMT9();
				fullscreen = false;
				CreateGLWindow("Lemonade",640,480,16,fullscreen);
				m_ProcessorMode = PROCESSOR_RUN_GL; break;
		case PROCESSOR_RUN_GL:
				GetMT9Data();							// MT9 Data
				DrawGLScene(&lpBi);                 // Draw Scene
				SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
				ProcessKeys();						// Keyboard
				m_ImageBitmap.CreateFromDib(lpBi);
				UpdateAllViews(NULL);
				break;
	default:	
					break;
	}
	bRunNow = FALSE;
}

void CFrameGrabberTestDoc::OnUpdateSimpleFilter(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ProcessorMode==PROCESSOR_IMAGE_FILTER);
	
}

void CFrameGrabberTestDoc::OnUpdateSimpleViewer(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ProcessorMode==PROCESSOR_SIMPLE_VIEWER);
	
}

void CFrameGrabberTestDoc::OnUpdateDetector(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ProcessorMode==PROCESSOR_MOTION_DETECTOR);
	
}
void CFrameGrabberTestDoc::OnUpdateGetData(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ProcessorMode==PROCESSOR_GET_DATA);
	
}

void CFrameGrabberTestDoc::OnDetector() 
{
	m_ProcessorMode=PROCESSOR_MOTION_DETECTOR;
}

void CFrameGrabberTestDoc::OnSimpleFilter() 
{
	m_ProcessorMode=PROCESSOR_IMAGE_FILTER;
	
}

void CFrameGrabberTestDoc::OnSimpleViewer() 
{
	m_ProcessorMode=PROCESSOR_SIMPLE_VIEWER;
}
void CFrameGrabberTestDoc::OnGetData()
{
	m_ProcessorMode=PROCESSOR_GET_DATA;
}
void CFrameGrabberTestDoc::OnInitWindow()
{
	m_ProcessorMode=PROCESSOR_INIT_WINDOW;

	//InitOpenGL();

}

void CFrameGrabberTestDoc::OnFileSaveAs() 
{
	UINT oldp=m_ProcessorMode;

	m_ProcessorMode=PROCESSOR_PAUSED;

	CDC *pDC=m_ImageBitmap.BegingModify();	
		pDC->SetTextColor(196);
		pDC->SetBkMode(TRANSPARENT);
		CSize sz=m_ImageBitmap.GetSize();
		char str[32];
		char str2[32];
		CString title;
	
		title.Format("REC %s %s", _strtime(str),_strdate(str2));;
		pDC->TextOut(16,sz.cy-16, title);
	m_ImageBitmap.EndModify();

	m_ImageBitmap.Save(NULL);
	m_ProcessorMode=oldp;
}

void CFrameGrabberTestDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable((BOOL)m_ImageBitmap.GetSafeHandle());
	
}
void CFrameGrabberTestDoc::OnUpdateInitWindow(CCmdUI* pCmdUI) 
{
	
}
void CFrameGrabberTestDoc::OnPause() 
{
	m_ProcessorMode=PROCESSOR_PAUSED;
	
}

void CFrameGrabberTestDoc::OnUpdatePause(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(m_ProcessorMode==PROCESSOR_PAUSED);
}

//////////////////////////////////////////////////////////
// Processor stuff
//
//
BOOL CFrameGrabberTestDoc::ApplyFilter(LPBITMAPINFO lpBi)
{/*

		ASSERT(lpBi);

		int arena_dx = IMAGEWIDTH(lpBi);
		int arena_dy = IMAGEHEIGHT(lpBi);

		//
		// This is the simplest Edge detector
		// Pixel(x0,y0)	= (abs(Pixel(x0,y0)-Pixel(x+1,y+1)) + abs(Pixel(x+1,y0)-Pixel(x0,y+1)))/2
		//

		switch(IMAGEBITS(lpBi))
		{
		case 32:
			{
				LONG * ptr =(LONG *)IMAGEDATA(lpBi);
				LONG * tmpLine = new LONG[arena_dx];

				for(int y=0; y<arena_dy-1;y++)
				{

					for(int x=0; x<arena_dx-1;x++)
					{
						int x1y1=x+arena_dx+1;
						int x1y0 =x+1;
						int x0y1=x+arena_dx;
						LONG r_diag1 = 	abs(ptr[x]&0xff -ptr[x1y1]&0xff);
						LONG g_diag1 = 	abs((ptr[x]>>8)&0xff - (ptr[x1y1]>>8)&0xff);
						LONG b_diag1 = 	abs((ptr[x]>>16)&0xff -(ptr[x1y1]>>16)&0xff);

						LONG r_diag2 = 	abs(ptr[x1y0]&0xff -ptr[x0y1]&0xff);
						LONG g_diag2 = 	abs((ptr[x1y0]>>8)&0xff -(ptr[x0y1]>>8)&0xff);
						LONG b_diag2 = 	abs((ptr[x1y0]>>16)&0xff -(ptr[x0y1]>>16)&0xff);
						
						tmpLine[x] = ((r_diag1+r_diag2)>>1) |
									 (((g_diag1+g_diag2)>>1)<<8) |
									 (((b_diag1+b_diag2)>>1)<<16);


					}
					memcpy(ptr,tmpLine, (arena_dx-1)*sizeof(DWORD));
					//printf("\n%i\n",tmpLine);
					ptr+=arena_dx;
				}
				
				delete tmpLine;
			}
			break;
		case 24:
			{
				BYTE * ptr =(BYTE *)IMAGEDATA(lpBi);
				BYTE * tmpLine = new BYTE[arena_dx*3];

				for(int y=0; y< arena_dy-1;y++)
				{

					for(int x=0; x<arena_dx-1; x++)
					{
						int x0y0 = x*3;
						int x1y1 = x0y0+arena_dx*3+3;
						int x1y0 = x0y0+3;
						int x0y1 = x0y0+arena_dx*3;
						LONG r_diag1 = 	abs( ptr[x0y0] - ptr[x1y1]);
						LONG g_diag1 = 	abs( ptr[x0y0+1] - ptr[x1y1+1]);
						LONG b_diag1 = 	abs( ptr[x0y0+2] - ptr[x1y1+2]);

						LONG r_diag2 = 	abs( ptr[x1y0] - ptr[x0y1]);
						LONG g_diag2 = 	abs( ptr[x1y0+1] - ptr[x0y1+1]);
						LONG b_diag2 = 	abs( ptr[x1y0+2] - ptr[x0y1+2]);
						
						tmpLine[x0y0]  = (BYTE)(r_diag1+r_diag2)>>1;
						tmpLine[x0y0+1]= (BYTE)(g_diag1+g_diag2)>>1;
						tmpLine[x0y0+2]= (BYTE)(b_diag1+b_diag2)>>1;


					}
					memcpy(ptr,tmpLine, (arena_dx-1)*3);
					//printf("\n%i\n",tmpLine);
					ptr+=arena_dx*3;
				}
				
				delete tmpLine;
			}
		default: break;
		}
		*/
	return TRUE;
	
}

BOOL CFrameGrabberTestDoc::GetData(LPBITMAPINFO lpBi)
{

		ASSERT(lpBi);

		int arena_dx = IMAGEWIDTH(lpBi);
		int arena_dy = IMAGEHEIGHT(lpBi);

		printf("\nGetting data...\n");

		switch(IMAGEBITS(lpBi))
		{
		case 32:
			{
				LONG * ptr =(LONG *)IMAGEDATA(lpBi);
				LONG * tmpLine = new LONG[arena_dx];

				for(int y=0; y<arena_dy-1;y++)
				{

					for(int x=0; x<arena_dx-1;x++)
					{
						int r_value;
						int g_value;
						int b_value;
						r_value = 	ptr[x]&0xff;
						g_value = 	(ptr[x]>>8)&0xff;
						b_value = 	(ptr[x]>>16)&0xff;
						
						tmpLine[x] = ((r_value) |
									 ((g_value)<<8) |
									 ((b_value)<<16));


					}
					memcpy(ptr,tmpLine, (arena_dx-1)*sizeof(DWORD));
					//printf("\n%i\n",tmpLine);
					ptr+=arena_dx;
				}
				
				delete tmpLine;
			}
			break;
		case 24:
			{
				BYTE * ptr =(BYTE *)IMAGEDATA(lpBi);
				BYTE * tmpLine = new BYTE[arena_dx*3];

				for(int y=0; y< arena_dy-1;y++)
				{

					for(int x=0; x<arena_dx-1; x++)
					{
						int x0y0 = x*3;
						int r_value;
						int g_value;
						int b_value;
						r_value = 	ptr[x0y0];
						g_value = 	ptr[x0y0+1];
						b_value = 	ptr[x0y0+2];
						
						tmpLine[x0y0]  = (BYTE)(r_value);
						tmpLine[x0y0+1]= (BYTE)(g_value);
						tmpLine[x0y0+2]= (BYTE)(b_value);


					}
					memcpy(ptr,tmpLine, (arena_dx-1)*3);
					//printf("\n%i\n",tmpLine);
					ptr+=arena_dx*3;
				}
				
				delete tmpLine;
			}
		default: break;
		}
	return TRUE;
}

BOOL CFrameGrabberTestDoc::InitOpenGL(LPBITMAPINFO lpBi)
{
	glMain(&lpBi);		
	return TRUE;
}



//Simplest Motion detector
BOOL CFrameGrabberTestDoc::RunDetector(LPBITMAPINFO lpBi)
{/*

	//constants definitions for motion detector
#define	ZONESX	4
#define	ZONESY	4
#define	ZONES	ZONESX*ZONESY
#define	DETECTION_LEVEL 0.05f

	static LONG lastIntensity[ZONES];
	static BOOL init = TRUE;

	LONG newIntensity[ZONES];

	int rx = IMAGEWIDTH(lpBi)/ZONESX;
	int ry = IMAGEHEIGHT(lpBi)/ZONESY;

	for(int y = 0; y<ZONESY; y++)
		for(int x = 0; x<ZONESX; x++)
			if(IMAGEBITS(lpBi)==32)
			 newIntensity[y*ZONESX+x] = summ_rect_arena32(  IMAGEDATA(lpBi),
															IMAGEWIDTH(lpBi),
															IMAGEHEIGHT(lpBi),
															x*rx, y*ry, rx, ry);
			else
			if(IMAGEBITS(lpBi)==24)
			 newIntensity[y*ZONESX+x] = summ_rect_arena24(IMAGEDATA(lpBi),
															IMAGEWIDTH(lpBi),
															IMAGEHEIGHT(lpBi),
															x*rx, y*ry, rx, ry);
			else return FALSE;

	BOOL ret=FALSE;
	if(!init)
	{
		FLOAT lastRel[ZONES-1];
		FLOAT newRel[ZONES-1];
		
		for(int i=0; i<ZONES-1; i++)
			lastRel[i] = (float)lastIntensity[i]/(float)(lastIntensity[i+1]+1);

		for(i=0; i< ZONES-1; i++)
		{
			newRel[i]= (float)newIntensity[i]/(float)(newIntensity[i+1]+1);
			
			float alarm = (float)fabs(lastRel[i]-newRel[i])/newRel[i];

			if(alarm >DETECTION_LEVEL)
				{ret=TRUE; break;}
		}

	
	}
	memcpy(lastIntensity,newIntensity, ZONES*sizeof(LONG));
	init = FALSE;
	return ret;
	*/
	return TRUE;
}

//some detectors stuff
LONG	summ_rect_arena32(LPBYTE data, int dx, int dy, int ptX, int ptY, int rx, int ry)
{
	LONG summ = 0;
	int lineBytes = dx*4;

	data+= (lineBytes*ptY + ptX*4);//offset

	for(int y = 0; y<ry; y++, data+=lineBytes)
		for(int x = 0; x< rx*4; x+=4)
		{
			summ+= data[x+1];
			summ+= data[x+2];
			summ+= data[x+3];
		}
	summ/=3;
	return summ;
}

LONG	summ_rect_arena24(LPBYTE data, int dx, int dy, int ptX, int ptY, int rx, int ry)
{
	LONG summ = 0;
	int lineBytes = dx*3;

	data+= (lineBytes*ptY + ptX*3);//offset

	for(int y = 0; y<ry; y++, data+=lineBytes)
		for(int x = 0; x< rx*3; x+=3)
		{
			summ+= data[x+0];
			summ+= data[x+1];
			summ+= data[x+2];
		}
	summ/=3;
	return summ;
}


///////////////////////// OpenGL Stuff
GLvoid ReSizeGLScene(GLsizei width, GLsizei height)		// Resize And Initialize The GL Window
{
	if (height==0)										// Prevent A Divide By Zero By
	{
		height=1;										// Making Height Equal One
	}

	glViewport(0,0,width,height);						// Reset The Current Viewport

	glMatrixMode(GL_PROJECTION);						// Select The Projection Matrix
	glLoadIdentity();									// Reset The Projection Matrix

	// Calculate The Aspect Ratio Of The Window
	gluPerspective(50.0f,(GLfloat)width/(GLfloat)height,10.f,1700.0f);

	glMatrixMode(GL_MODELVIEW);							// Select The Modelview Matrix
	glLoadIdentity();									// Reset The Modelview Matrix
}

/************************************************************************************/

int InitGL(GLvoid)										// All Setup For OpenGL Goes Here
{
   	float df=100.0;

	glClearDepth(1.0f);									// Depth Buffer Setup
	glEnable(GL_DEPTH_TEST);							// Enables Depth Testing
	glDepthFunc(GL_LEQUAL);								// The Type Of Depth Testing To Do
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);	// Really Nice Perspective Calculations

	glClearColor(0,0,0,0);
  	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

	glShadeModel(GL_SMOOTH);
	glEnable(GL_CULL_FACE);
	glEnable(GL_DEPTH_TEST);

	
	glMaterialfv(GL_FRONT,GL_SPECULAR,spec);
	glMaterialfv(GL_FRONT,GL_SHININESS,&df);

	glEnable(GL_LIGHTING);
	glLightfv(GL_LIGHT0,GL_POSITION,posl);
	glLightfv(GL_LIGHT0,GL_AMBIENT,amb2);
	glEnable(GL_LIGHT0);

	glLightModelfv(GL_LIGHT_MODEL_AMBIENT,amb);
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT,GL_AMBIENT_AND_DIFFUSE);
   
	glEnable(GL_BLEND);
    glBlendFunc(GL_SRC_ALPHA, GL_ONE);

	return TRUE;										// Initialization Went OK
}

/************************************************************************************/

int DrawGLScene(LPBITMAPINFO *frame)	            // Here's Where We Do All The Drawing
{								
	glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();

    gluLookAt(pos[0],pos[1],pos[2], pos[0]+dir[0],pos[1]+dir[1],pos[2]+dir[2], 0,1.0,0.0);
	
	float colorNorm = 255.0f;

	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

    glRotatef(camera_rotation,0,1,0);
	glRotatef(vert_rotation,1,0,0);

	glBegin(GL_QUADS);

	LPBITMAPINFO lpBi = *(frame);

	ASSERT(lpBi);

	int arena_dx = IMAGEWIDTH(lpBi);
	int arena_dy = IMAGEHEIGHT(lpBi);

	printf("\nGetting data...\n");

	switch(IMAGEBITS(lpBi))
	{
	case 32:
		{
			LONG * ptr =(LONG *)IMAGEDATA(lpBi);
			LONG * tmpLine = new LONG[arena_dx];

			for(int y=0; y<arena_dy-1;y++)
			{

				for(int x=0; x<arena_dx-1;x++)
				{
					int r_value;
					int g_value;
					int b_value;
					r_value = 	ptr[x]&0xff;
					g_value = 	(ptr[x]>>8)&0xff;
					b_value = 	(ptr[x]>>16)&0xff;


				}
				ptr+=arena_dx;
			}
			
			delete tmpLine;
		}
		break;
	case 24:
		{
			BYTE * ptr =(BYTE *)IMAGEDATA(lpBi);
			//BYTE * tmpLine = new BYTE[arena_dx*3];

			int n = arena_dy * pow((fOrientationData[0] / 180.0f),2) + 1;
			int yaw  = abs(fOrientationData[2]);

			//int n = 1;
			if (n>arena_dy)
				n = arena_dy;

			for(int y=0; y< arena_dy-n;y+=n)
			{

				for(int x=0; x<arena_dx-n; x+=n)
				{
					int x0y0 = x*3;
					int x1y1 = x0y0+arena_dx*3*n+3*n;
					int x1y0 = x0y0+3*n;
					int x0y1 = x0y0+arena_dx*n*3;
					float val0 = (ptr[x0y0] + ptr[x0y0+1] + ptr[x0y0+2])/3.0f;
					float val1 = (ptr[x1y1] + ptr[x1y1+1] + ptr[x1y1+2])/3.0f;
					float val2 = (ptr[x1y0] + ptr[x1y0+1] + ptr[x1y0+2])/3.0f;
					float val3 = (ptr[x0y1] + ptr[x0y1+1] + ptr[x0y1+2])/3.0f;


					glColor3f((yaw*(ptr[x0y0+2]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x0y0+1]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x0y0]/colorNorm)+(180-yaw)*0.5f)/180);
					glVertex3f(-arena_dx/2 + x,-arena_dy/2 + y, fOrientationData[1]*val0/45);
					
					glColor3f((yaw*(ptr[x0y1+2]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x0y1+1]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x0y1]/colorNorm)+(180-yaw)*0.5f)/180);
					glVertex3f(-arena_dx/2 + x,-arena_dy/2 + y+n,val3*fOrientationData[1]/45);

					glColor3f((yaw*(ptr[x1y1+2]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x1y1+1]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x1y1]/colorNorm)+(180-yaw)*0.5f)/180);
					glVertex3f(-arena_dx/2 +x+n,-arena_dy/2 +y+n,val1*fOrientationData[1]/45);

					glColor3f((yaw*(ptr[x1y0+2]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x1y0+1]/colorNorm)+(180-yaw)*0.5f)/180,(yaw*(ptr[x1y0]/colorNorm)+(180-yaw)*0.5f)/180);
					glVertex3f(-arena_dx/2 +x+n,-arena_dy/2 +y,val2*fOrientationData[1]/45);
				}
				ptr+=arena_dx*3*n;
			}
		}
/*
			int n = 4;

			for(int y=0; y< arena_dy-1;y+=n)
			{

				for(int x=0; x<arena_dx-1; x+=n)
				{
					int x0y0 = x*3;
					int x1y1 = x0y0+arena_dx*3*n+3*n;
					int x1y0 = x0y0+3*n;
					int x0y1 = x0y0+arena_dx*n*3;


					glColor3f(ptr[x0y0+2]/colorNorm,ptr[x0y0+1]/colorNorm,ptr[x0y0]/colorNorm);
					glVertex3f(-arena_dx/2 + x,-arena_dy/2 + y, ptr[x0y0]);
					
					glColor3f(ptr[x0y1+2]/colorNorm,ptr[x0y1+1]/colorNorm,ptr[x0y1]/colorNorm);
					glVertex3f(-arena_dx/2 + x,-arena_dy/2 + y+n,ptr[x0y1]);

					glColor3f(ptr[x1y1+2]/colorNorm,ptr[x1y1+1]/colorNorm,ptr[x1y1]/colorNorm);
					glVertex3f(-arena_dx/2 +x+n,-arena_dy/2 +y+n,ptr[x1y1]);

					glColor3f(ptr[x1y1+2]/colorNorm,ptr[x1y1+1]/colorNorm,ptr[x1y1]/colorNorm);	
					glVertex3f(-arena_dx/2 +x+n,-arena_dy/2 +y,ptr[x1y0]);
				}
				ptr+=arena_dx*3*n;
			}
			
		}

		*/
	default: break;
	}

	glEnd();

	//glDepthMask(GL_TRUE);
	glDisable(GL_BLEND);
 

	return TRUE;										// Keep Going
}


/************************************************************************************/

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (fullscreen)										// Are We In Fullscreen Mode?
	{
		if (!ChangeDisplaySettings(NULL,CDS_TEST)) { // if the shortcut doesn't work
			ChangeDisplaySettings(NULL,CDS_RESET);		// Do it anyway (to get the values out of the registry)
			ChangeDisplaySettings(&DMsaved,CDS_RESET);	// change it to the saved settings
		} else {
			ChangeDisplaySettings(NULL,CDS_RESET);
		}
			
		ShowCursor(TRUE);								// Show Mouse Pointer
	}

	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}
}

/************************************************************************************/

/*	This Code Creates Our OpenGL Window.  Parameters Are:					*
 *	title			- Title To Appear At The Top Of The Window				*
 *	width			- Width Of The GL Window Or Fullscreen Mode				*
 *	height			- Height Of The GL Window Or Fullscreen Mode			*
 *	bits			- Number Of Bits To Use For Color (8/16/24/32)			*
 *	fullscreenflag	- Use Fullscreen Mode (TRUE) Or Windowed Mode (FALSE)	*/
 
BOOL CreateGLWindow(char* title, int width, int height, int bits, bool fullscreenflag)
{
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	RECT		WindowRect;				// Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)width;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)height;		// Set Bottom Value To Requested Height

	fullscreen=fullscreenflag;			// Set The Global Fullscreen Flag

	hInstance			= GetModuleHandle(NULL);				// Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name
	
	EnumDisplaySettings(NULL, ENUM_CURRENT_SETTINGS, &DMsaved); // save the current display state (NEW)

	if (fullscreen)												// Attempt Fullscreen Mode?
	{
		DEVMODE dmScreenSettings;								// Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	// Makes Sure Memory's Cleared
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);		// Size Of The Devmode Structure
		dmScreenSettings.dmPelsWidth	= width;				// Selected Screen Width
		dmScreenSettings.dmPelsHeight	= height;				// Selected Screen Height
		dmScreenSettings.dmBitsPerPel	= bits;					// Selected Bits Per Pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		// Try To Set Selected Mode And Get Results.  NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			// If The Mode Fails, Offer Two Options.  Quit Or Use Windowed Mode.
			if (MessageBox(NULL,"The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?","NeHe GL",MB_YESNO|MB_ICONEXCLAMATION)==IDYES)
			{
				fullscreen=FALSE;		// Windowed Mode Selected.  Fullscreen = FALSE
			}
			else
			{
				// Pop Up A Message Box Letting User Know The Program Is Closing.
				MessageBox(NULL,"Program Will Now Close.","ERROR",MB_OK|MB_ICONSTOP);
				return FALSE;									// Return FALSE
			}
		}
	}

	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;											// Return FALSE
	}

	if (fullscreen)												// Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								// Window Extended Style
		dwStyle=WS_POPUP;										// Windows Style
		ShowCursor(FALSE);										// Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);		// Adjust Window To True Requested Size

	// Create The Window
	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								title,								// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		bits,										// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	// Did Windows Find A Matching Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Find A Suitable PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		// Are We Able To Set The Pixel Format?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Set The PixelFormat.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if (!(hRC=wglCreateContext(hDC)))				// Are We Able To Get A Rendering Context?
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Create A GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	if(!wglMakeCurrent(hDC,hRC))					// Try To Activate The Rendering Context
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Can't Activate The GL Rendering Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	ShowWindow(hWnd,SW_SHOW);						// Show The Window
	SetForegroundWindow(hWnd);						// Slightly Higher Priority
	SetFocus(hWnd);									// Sets Keyboard Focus To The Window
	ReSizeGLScene(width, height);					// Set Up Our Perspective GL Screen

    if (!InitGL())									// Initialize Our Newly Created GL Window
	{
		KillGLWindow();								// Reset The Display
		MessageBox(NULL,"Initialization Failed.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;								// Return FALSE
	}

	return TRUE;									// Success
}

/************************************************************************************/
// (no changes)

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{
	switch (uMsg)									// Check For Windows Messages
	{
		case WM_ACTIVATE:							// Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					// Check Minimization State
			{
				active=TRUE;						// Program Is Active
			}
			else
			{
				active=FALSE;						// Program Is No Longer Active
			}

			return 0;								// Return To The Message Loop
		}

		case WM_SYSCOMMAND:							// Intercept System Commands
		{
			switch (wParam)							// Check System Calls
			{
				case SC_SCREENSAVE:					// Screensaver Trying To Start?
				case SC_MONITORPOWER:				// Monitor Trying To Enter Powersave?
				return 0;							// Prevent From Happening
			}
			break;									// Exit
		}

		case WM_CLOSE:								// Did We Receive A Close Message?
		{
			PostQuitMessage(0);						// Send A Quit Message
			return 0;								// Jump Back
		}

		case WM_KEYDOWN:							// Is A Key Being Held Down?
		{
			keys[wParam] = TRUE;					// If So, Mark It As TRUE
			return 0;								// Jump Back
		}

		case WM_KEYUP:								// Has A Key Been Released?
		{
			keys[wParam] = FALSE;					// If So, Mark It As FALSE
			return 0;								// Jump Back
		}

		case WM_SIZE:								// Resize The OpenGL Window
		{
			ReSizeGLScene(LOWORD(lParam),HIWORD(lParam));  // LoWord=Width, HiWord=Height
			return 0;								// Jump Back
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

/************************************************************************************/

int glMain(LPBITMAPINFO *frame)			// Window Show State
{
	MSG		msg;									// Windows Message Structure
	BOOL	done=FALSE;								// Bool Variable To Exit Loop

	// Ask The User Which Screen Mode They Prefer
	if (MessageBox(NULL,"Would You Like To Run In Fullscreen Mode?", "Start FullScreen?",MB_YESNO|MB_ICONQUESTION)==IDNO)
	{
		fullscreen=FALSE;							// Windowed Mode
	}

	InitVars();                                     // Initialize Variables

	// Create Our OpenGL Window
	if (!CreateGLWindow("Lemonade",640,480,16,fullscreen))
	{
		return 0;									// Quit If Window Was Not Created
	}

	while(!done)									// Loop That Runs While done=FALSE
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	// Is There A Message Waiting?
		{
			if (msg.message==WM_QUIT)				// Have We Received A Quit Message?
			{
				done=TRUE;							// If So done=TRUE
			}
			else									// If Not, Deal With Window Messages
			{
				TranslateMessage(&msg);				// Translate The Message
				DispatchMessage(&msg);				// Dispatch The Message
			}
		}
		else										// If There Are No Messages
		    if (active)
			{
				// Draw The Scene.  Watch For ESC Key And Quit Messages From DrawGLScene()
				if (keys[VK_ESCAPE])	// Active?  Was There A Quit Received?
				{
					done=TRUE;							// ESC or DrawGLScene Signalled A Quit
				}
				else									// Not Time To Quit, Update Screen
				{
					DrawGLScene(frame);                      // Draw Scene
					SwapBuffers(hDC);					// Swap Buffers (Double Buffering)
				}
	
				if (!ProcessKeys()) return 0;
			}
	}

	// Shutdown
	KillGLWindow();									// Kill The Window
	return (msg.wParam);							// Exit The Program
}


void InitVars()
{

}

int ProcessKeys()
{
	if (keys[VK_F3])    pos[2]+=-10;
	if (keys[VK_F4])    pos[2]+=10;
	if (keys[VK_DOWN])    vert_rotation+=-10;
	if (keys[VK_UP])    vert_rotation+=10;
	if (keys[VK_LEFT])  camera_rotation+=10;
	if (keys[VK_RIGHT]) camera_rotation-=10;

	if (keys[VK_F1])						// Is F1 Being Pressed?
	{
		keys[VK_F1]=FALSE;					// If So Make Key FALSE
		KillGLWindow();						// Kill Our Current Window
		fullscreen=!fullscreen;				// Toggle Fullscreen / Windowed Mode
		// Recreate Our OpenGL Window
		CreateGLWindow("Lemonade",640,480,16,fullscreen);
	}

	return 1;
}

void initMT9()
{
	CoInitialize(NULL);
	SetupFilter();
	
	// Start processing by MotionTracker object
	pMT->MT_StartProcess();
}

void killMT9()
{
	pMT->Release();

	// Uninitialize COM library
	CoUninitialize();
}

void SetupFilter()
{
	// Set MTObj COM object options
	short m_bLogCalibratedData = FALSE;

	// Set MTObj COM object variables
	float fGain = 1.0;
	short nCorInterval = 1;
	float fRho = 1.0;
	short nPortNumber = 1;

	//////////////////////////////////////////////////////////////////////////
	// Sample frequency and .XMU file location not needed with MT9-B
	// Sample frequency and .XMU file location needed with MT9-A
	//short nSampleFreq = 100;
	//wchar_t* wszIn = L"D:\\2025_07082002_000.xmu";
	//
	//// Allocate string and copy wszIn
	//BSTR bstrIn;
	//bstrIn = ::SysAllocString(wszIn);
	//////////////////////////////////////////////////////////////////////////
	
	// Create instance of MTObj COM object
	//printf("Create instance of MotionTracker object...");
	HRESULT hRes = CoCreateInstance(CLSID_MotionTracker, NULL, CLSCTX_SERVER, IID_IMotionTracker, (void**) &pMT);
	if (FAILED(hRes))
	{
		//printf("Error %x in CoCreateInstance for MT object!",hRes);
		return;
	}
	else
		//printf("done\n\n");


	//printf("Setting filter parameters...");
	// Optional settings
	pMT->MT_SetCalibratedOutput(m_bLogCalibratedData);

	// Set Gain, Correction interval and Rho
	pMT->MT_SetFilterSettings(fGain,nCorInterval,fRho);

	// Required settings
	pMT->MT_SetOutputMode(g_nMode);

	// Set COM port number (1-15) where MT9 is attached
	pMT->MT_SetCOMPort(nPortNumber);

	//////////////////////////////////////////////////////////////////////////
	// Sample frequency and .XMU file location not needed with MT9-B
	// Sample frequency and .XMU file location need with MT9-A
	//pMT->MT_SetSampleFrequency(nSampleFreq);
	//
	//// Set .XMU file location
	//pMT->MT_SetxmuLocationBSTR(bstrIn);
	//
	//// Free allocated string
	//::SysFreeString(bstrIn);
	//////////////////////////////////////////////////////////////////////////
	
	//printf("done\n\n");
}
 
BOOL GetMT9Data()
{

	VARIANT OrientationBuffer;
	void* pDest;
	short nNew = 0;

	BOOL bNewData = FALSE;

	pMT->MT_GetOrientationData(&nNew, &OrientationBuffer);
	if (nNew == MT_NEWDATA) 
	{
		// Check if array is not empty
		if (OrientationBuffer.vt != VT_EMPTY)
		{
			// Retrieve pointer to array data
			HRESULT hr = SafeArrayAccessData(OrientationBuffer.parray, &pDest);
			// One dimensional array. Get the bounds for the array.
					         
			if (SUCCEEDED(hr))
			{				
				__try{
					// Copy data from the VARIANT array to the local fData array
					memcpy(fOrientationData,pDest,(OrientationBuffer.parray->rgsabound->cElements * sizeof(float)));
					bNewData = TRUE;
				}
				__except(GetExceptionCode() == STATUS_ACCESS_VIOLATION){
					bNewData = FALSE;
				}	
			
				SafeArrayUnaccessData(OrientationBuffer.parray);	// Invalidate pointer

				// Variant must be cleared. This also destroys the SafeArray
				VariantClear(&OrientationBuffer);
	
				// fOrientationData now contains orientation data is bNewData = true
				// Can be logged to file or written to screen (see below)
			
				if (g_nMode == MT_LOGEULER)
				{
					//printf("%f %f %f\n",fOrientationData[0],fOrientationData[1],fOrientationData[2]);	
				}

				bNewData = FALSE;

				return TRUE;
			}
			else
				return FALSE;
		}
		else
			return FALSE;
	}
	else if (nNew != 0)
	{		
		// Check if error was reported by MotionTracker object
		switch(nNew) {
		case MT_NODATA:
			//printf("No Data On COM Port\n\n");
			break;
		case MT_NOSENSORID:
			//printf("No Sensor ID Received From Sensor\n\n");
			break;
		case MT_INCOMPLETE:
			//printf("Incomplete Data Received (Connection Lost)\n\n");
			break;
		case MT_CHECKSUMERROR:
			//printf("Checksum Error\n\n");
			break;
		case MT_NOPORT:
			//printf("COM Port Could Not Be Opened\n\n");
			break;
		case MT_NOCALIBVALUES:
			//printf("XMU File With Calibration Data Could Not Be Read or \nMTS Data With Calibration Data Not Set\n\n");
			break;	
		case MT_POWERLOSS:
			//printf("Power Supply To The Sensor Was Probably Interupted\n\n");
			break;
		}
		
		return FALSE;
	}
	else
		return TRUE;
	
}